(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('ng7-large-files-upload-lib', ['exports', '@angular/core', '@angular/common', 'rxjs', '@angular/common/http'], factory) :
    (factory((global['ng7-large-files-upload-lib'] = {}),global.ng.core,global.ng.common,global.rxjs,global.ng.common.http));
}(this, (function (exports,i0,common,rxjs,i2) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7LargeFilesUploadLibComponent = /** @class */ (function () {
        function Ng7LargeFilesUploadLibComponent(service) {
            this.service = service;
            /**
             * if true the component will be responsible to send data at the specified endpoint
             */
            this.canSendData = false;
            /**
             * Allows to download attachments
             */
            this.canDownload = true;
            /**
             * Upload new attachments behavior
             */
            this.canUpload = true;
            /**
             * Delete attachments uploaded behavior
             */
            this.canDelete = true;
            /**
             * Text for save button if canSendData = true
             */
            this.saveButtonText = "Guardar";
            /**
             * Initial attachments
             */
            this._attachments = [];
            //Attachments added
            this._newAttachments = [];
            //Attachments wich already have
            this._oldAttachments = [];
            /**
             * Return the list of attachments in each change
             */
            this.updatedAttachmentsEmitter = new i0.EventEmitter();
            this.files = new Array();
        }
        /**
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                //Clone initial attachments array
                this._oldAttachments = JSON.parse(JSON.stringify(this._attachments));
            };
        // public _newAttachments: Set<File> = new Set();
        // public _newAttachments: Set<File> = new Set();
        /**
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.addFiles =
            // public _newAttachments: Set<File> = new Set();
            /**
             * @return {?}
             */
            function () {
                this.file.nativeElement.click();
            };
        /**
         * @param {?} f
         * @param {?} aArray
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.removeFiles = /**
         * @param {?} f
         * @param {?} aArray
         * @return {?}
         */
            function (f, aArray) {
                this.deleteFromArray(f, aArray);
                this.removeFromAllAttachments(f);
            };
        /**
         * @param {?} f
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.deleteFiles = /**
         * @param {?} f
         * @return {?}
         */
            function (f) {
                /** @type {?} */
                var a = this._attachments.find(( /**
                 * @param {?} x
                 * @return {?}
                 */function (x) { return x.id == f.id; }));
                a.isDelete = true;
                a.isInsert = false;
                this.deleteFromArray(a, this._oldAttachments);
            };
        /**
         * @param {?} f
         * @param {?} aArray
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.deleteFromArray = /**
         * @param {?} f
         * @param {?} aArray
         * @return {?}
         */
            function (f, aArray) {
                aArray.forEach(( /**
                 * @param {?} item
                 * @param {?} index
                 * @return {?}
                 */function (item, index) {
                    if ((item.fileName === f.name || item.name === f.name))
                        aArray.splice(index, 1);
                }));
                this.updatedAttachmentsEmitter.emit(this._attachments);
            };
        /**
         * @param {?} f
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.removeFromAllAttachments = /**
         * @param {?} f
         * @return {?}
         */
            function (f) {
                var _this = this;
                this._attachments.forEach(( /**
                 * @param {?} item
                 * @param {?} index
                 * @return {?}
                 */function (item, index) {
                    if (item === f)
                        _this._attachments.splice(index, 1);
                }));
                this.updatedAttachmentsEmitter.emit(this._attachments);
            };
        /**
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.onFilesAdded = /**
         * @return {?}
         */
            function () {
                var _this = this;
                Array.prototype.forEach.call(this.file.nativeElement.files, ( /**
                 * @param {?} f
                 * @return {?}
                 */function (f) {
                    /** @type {?} */
                    var newAttach = _this._newAttachments.find(( /**
                     * @param {?} x
                     * @return {?}
                     */function (x) { return x.name == f.name; }));
                    /** @type {?} */
                    var oldAttach = _this._oldAttachments.find(( /**
                     * @param {?} x
                     * @return {?}
                     */function (x) { return x.name == f.name; }));
                    /** @type {?} */
                    var attach = _this._attachments.find(( /**
                     * @param {?} x
                     * @return {?}
                     */function (x) { return x.name == f.name; }));
                    /** @type {?} */
                    var attachNew = _this._attachments.find(( /**
                     * @param {?} x
                     * @return {?}
                     */function (x) { return x.name == f.name && x.id == undefined; }));
                    if (newAttach) {
                        _this.deleteFromArray(newAttach, _this._newAttachments);
                        if (attachNew) {
                            _this.removeFromAllAttachments(attachNew);
                        }
                    }
                    else if (oldAttach) {
                        _this.deleteFiles(attach);
                        _this.deleteFromArray(oldAttach, _this._oldAttachments);
                    }
                    f.isInsert = true;
                    f.isDelete = false;
                    _this.files.push(f);
                    _this._newAttachments.push(f);
                    _this._attachments.push(f);
                    _this.updatedAttachmentsEmitter.emit(_this._attachments);
                }));
            };
        /**
         * @return {?}
         */
        Ng7LargeFilesUploadLibComponent.prototype.onSaveChanges = /**
         * @return {?}
         */
            function () {
                if (!this.canSendData)
                    return;
                /** @type {?} */
                var uploadStatus = this.service.upload(this._attachments);
                /** @type {?} */
                var allProgressObservables = [];
                for (var key in uploadStatus) {
                    allProgressObservables.push(uploadStatus[key].progress);
                }
                if (allProgressObservables != undefined) {
                    rxjs.forkJoin(allProgressObservables).subscribe(( /**
                     * @param {?} end
                     * @return {?}
                     */function (end) {
                        console.log("all finished");
                    }));
                }
            };
        Ng7LargeFilesUploadLibComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'mb-large-files-uploader',
                        template: "<div>\r\n  <input type=\"file\" #file style=\"display: none\" (change)=\"onFilesAdded()\" multiple />\r\n  <div class=\"evidences-icon-container\">\r\n    <span>{{title}}</span>\r\n    <i *ngIf=\"canUpload\" class=\"material-icons add-file-icon\" (click)=\"addFiles()\">add_circle</i>\r\n  </div>\r\n  <div *ngIf=\"canDownload || canDelete\">\r\n    <div class=\"file-container\" *ngFor=\"let oa of _oldAttachments\">\r\n      <a *ngIf=\"canDownload\" href=\"{{oa.url}}\">\r\n        <i class=\"material-icons file-icon download-file-icon\">vertical_align_bottom</i>\r\n      </a>\r\n      <i *ngIf=\"canDelete\" class=\"material-icons file-icon delete-file-icon\" (click)=\"deleteFiles(oa)\">delete</i>\r\n      <span>{{oa.name}}</span>\r\n    </div>\r\n  </div>\r\n  <div *ngIf=\"canUpload\">\r\n    <div class=\"file-container\" *ngFor=\"let na of _newAttachments\">\r\n      <i class=\"material-icons file-icon remove-file-icon\" (click)=\"removeFiles(na, _newAttachments)\">remove_circle</i>\r\n      <span>{{na.name}}</span>\r\n    </div>\r\n  </div>\r\n</div>\r\n<button *ngIf=\"canSendData\" (click)=\"onSaveChanges()\">{{saveButtonText}}</button>",
                        styles: [".attachments-title{font-size:16px}.add-file-icon{color:#397fbb;cursor:pointer;vertical-align:bottom;margin-left:15px}.file-icon{cursor:pointer;vertical-align:bottom;margin-left:15px;margin-right:15px}.remove-file-icon{color:#d62121}.download-file-icon{color:#000}.delete-file-icon{color:red}.evidences-container{margin-bottom:40px}.evidences-icon-container{margin-bottom:20px}.file-container{margin-top:10px}div{font-family:Roboto}@font-face{font-family:Roboto;font-style:normal;font-weight:500;src:local('Roboto Medium'),local('Roboto-Medium'),url(https://fonts.gstatic.com/s/roboto/v18/KFOlCnqEu92Fr1MmEU9fChc4EsA.woff2) format('woff2');unicode-range:U+0100-024F,U+0259,U+1E00-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF}@font-face{font-family:'Material Icons';font-style:normal;font-weight:400;src:url(https://fonts.gstatic.com/s/materialicons/v43/flUhRq6tzZclQEJ-Vdg-IuiaDsNc.woff2) format('woff2')}.material-icons{font-family:'Material Icons';font-weight:400;font-style:normal;font-size:24px;line-height:1;letter-spacing:normal;text-transform:none;display:inline-block;white-space:nowrap;word-wrap:normal;direction:ltr;-webkit-font-feature-settings:'liga';-webkit-font-smoothing:antialiased}"]
                    }] }
        ];
        /** @nocollapse */
        Ng7LargeFilesUploadLibComponent.ctorParameters = function () {
            return [
                { type: Ng7LargeFilesUploadLibService }
            ];
        };
        Ng7LargeFilesUploadLibComponent.propDecorators = {
            file: [{ type: i0.ViewChild, args: ['file',] }],
            canSendData: [{ type: i0.Input }],
            canDownload: [{ type: i0.Input }],
            canUpload: [{ type: i0.Input }],
            canDelete: [{ type: i0.Input }],
            title: [{ type: i0.Input }],
            saveButtonText: [{ type: i0.Input }],
            _attachments: [{ type: i0.Input }],
            updatedAttachmentsEmitter: [{ type: i0.Output }]
        };
        return Ng7LargeFilesUploadLibComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var BASE_URL = new i0.InjectionToken('BASE_URL');
    var Ng7LargeFilesUploadLibModule = /** @class */ (function () {
        function Ng7LargeFilesUploadLibModule() {
        }
        /**
         * @param {?} host
         * @return {?}
         */
        Ng7LargeFilesUploadLibModule.forRoot = /**
         * @param {?} host
         * @return {?}
         */
            function (host) {
                return {
                    ngModule: Ng7LargeFilesUploadLibModule,
                    providers: [{
                            provide: BASE_URL,
                            useValue: host
                        }]
                };
            };
        Ng7LargeFilesUploadLibModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [Ng7LargeFilesUploadLibComponent],
                        imports: [
                            common.CommonModule,
                            i2.HttpClientModule,
                        ],
                        exports: [Ng7LargeFilesUploadLibComponent]
                    },] }
        ];
        return Ng7LargeFilesUploadLibModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7LargeFilesUploadLibService = /** @class */ (function () {
        function Ng7LargeFilesUploadLibService(base, _httpClient) {
            this._httpClient = _httpClient;
            this.BASE_URL = base;
        }
        /**
         * @param {?} files
         * @return {?}
         */
        Ng7LargeFilesUploadLibService.prototype.upload = /**
         * @param {?} files
         * @return {?}
         */
            function (files) {
                var _this = this;
                debugger;
                /** @type {?} */
                var status = {};
                /** @type {?} */
                var url = this.BASE_URL;
                files.forEach(( /**
                 * @param {?} file
                 * @return {?}
                 */function (file) {
                    /** @type {?} */
                    var formData = new FormData();
                    formData.append('file', file, file.name);
                    /** @type {?} */
                    var req = new i2.HttpRequest('POST', url, formData, {
                        reportProgress: true
                    });
                    /** @type {?} */
                    var progress = new rxjs.Subject();
                    _this._httpClient.request(req).subscribe(( /**
                     * @param {?} event
                     * @return {?}
                     */function (event) {
                        if (event.type === i2.HttpEventType.UploadProgress) {
                            /** @type {?} */
                            var percentDone = Math.round(100 * event.loaded / event.total);
                            progress.next(percentDone);
                        }
                        else if (event instanceof i2.HttpResponse) {
                            progress.complete();
                        }
                    }));
                    status[file.name] = {
                        progress: progress.asObservable()
                    };
                }));
                return status;
            };
        Ng7LargeFilesUploadLibService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Ng7LargeFilesUploadLibService.ctorParameters = function () {
            return [
                { type: String, decorators: [{ type: i0.Inject, args: [BASE_URL,] }] },
                { type: i2.HttpClient }
            ];
        };
        /** @nocollapse */ Ng7LargeFilesUploadLibService.ngInjectableDef = i0.defineInjectable({ factory: function Ng7LargeFilesUploadLibService_Factory() { return new Ng7LargeFilesUploadLibService(i0.inject(BASE_URL), i0.inject(i2.HttpClient)); }, token: Ng7LargeFilesUploadLibService, providedIn: "root" });
        return Ng7LargeFilesUploadLibService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.Ng7LargeFilesUploadLibService = Ng7LargeFilesUploadLibService;
    exports.Ng7LargeFilesUploadLibComponent = Ng7LargeFilesUploadLibComponent;
    exports.BASE_URL = BASE_URL;
    exports.Ng7LargeFilesUploadLibModule = Ng7LargeFilesUploadLibModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ng7-large-files-upload-lib.umd.js.map