import { OnInit, EventEmitter } from '@angular/core';
import { Ng7LargeFilesUploadLibService } from './ng7-large-files-upload-lib.service';
export declare class Ng7LargeFilesUploadLibComponent implements OnInit {
    private service;
    constructor(service: Ng7LargeFilesUploadLibService);
    ngOnInit(): void;
    file: any;
    /**
     * if true the component will be responsible to send data at the specified endpoint
     */
    canSendData: boolean;
    /**
     * Allows to download attachments
     */
    canDownload: Boolean;
    /**
     * Upload new attachments behavior
     */
    canUpload: Boolean;
    /**
     * Delete attachments uploaded behavior
     */
    canDelete: Boolean;
    /**
     * Label for formControl
     */
    title: String;
    /**
     * Text for save button if canSendData = true
     */
    saveButtonText: String;
    /**
     * Initial attachments
    */
    _attachments: Array<MyFile>;
    _newAttachments: Array<MyFile>;
    _oldAttachments: Array<MyFile>;
    /**
     * Return the list of attachments in each change
     */
    updatedAttachmentsEmitter: EventEmitter<any>;
    addFiles(): void;
    files: MyFile[];
    removeFiles(f: any, aArray: any): void;
    deleteFiles(f: any): void;
    deleteFromArray(f: any, aArray: any): void;
    removeFromAllAttachments(f: any): void;
    onFilesAdded(): void;
    onSaveChanges(): void;
}
export interface MyFile extends File {
    isInsert: any;
    isDelete: any;
    id: any;
    url: any;
}
